<?php
/**
 * VC Simple Gallery config
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

vc_map(array(
	'name' => esc_html__('Simple Gallery', 'uncode-core') ,
	'base' => 'uncode_simple_gallery',
	'weight' => 9000,
	'icon' => 'fa fa-camera',
	'description' => esc_html__('Gallery media images', 'uncode-core') ,
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__('Title', 'uncode-core') ,
			'param_name' => 'title',
			'description' => esc_html__('Enter text which will be used as module title. Leave blank if no title is needed.', 'uncode-core')
		) ,
		array(
			'type' => 'param_group',
			'heading' => esc_html__('Graphic values', 'uncode-core') ,
			'param_name' => 'values',
			'description' => esc_html__( 'Enter values for graph - value, title and color.', 'uncode-core' ),
			'value' => urlencode( json_encode( array(
				array(
					'label' => esc_html__( 'Development', 'uncode-core' ),
					'value' => '90',
				),
				array(
					'label' => esc_html__( 'Design', 'uncode-core' ),
					'value' => '80',
				),
				array(
					'label' => esc_html__( 'Marketing', 'uncode-core' ),
					'value' => '70',
				),
			) ) ),
			'params' => array(
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Label', 'uncode-core' ),
					'param_name' => 'label',
					'description' => esc_html__( 'Enter text used as title of bar.', 'uncode-core' ),
					'admin_label' => true,
				),
				array(
					"type" => "media_element",
					"heading" => esc_html__("Media", 'uncode-core') ,
					"param_name" => "media",
					"value" => "",
					//"edit_field_class" => 'vc_column uncode_single_media',
					"description" => esc_html__("Specify a media from the Media Library.", 'uncode-core') ,
					"admin_label" => true
				) ,

			),
		),
		array(
			'type' => 'textfield',
			'heading' => esc_html__('Element ID', 'uncode-core') ,
			'param_name' => 'el_id',
			'description' => esc_html__('This value has to be unique. Change it in case it\'s needed.', 'uncode-core') ,
			"group" => esc_html__("Extra", 'uncode-core') ,
		) ,
		array(
			'type' => 'textfield',
			'heading' => esc_html__('Extra class name', 'uncode-core') ,
			'param_name' => 'el_class',
			'description' => esc_html__('If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your CSS file.', 'uncode-core'),
			"group" => esc_html__("Extra", 'uncode-core') ,
		)
	)
));
